/// Статья - https://habrahabr.ru/post/310186/
@function responsive-size($val-min, $val-max, $viewport-min, $viewport-max, $important: '', $units: px) {
  // ------- prepare incoming data -------
  $val-min: strip-units($val-min);
  $val-max: strip-units($val-max);
  $viewport-min: strip-units($viewport-min);
  $viewport-max: strip-units($viewport-max);
  // ------- END prepare incoming data -------

  $k: ($val-max - $val-min) / ($viewport-max - $viewport-min);
  $b: $val-min - $k * $viewport-min;

  $b: $b + $units;

  @return calc(#{$k} * 100vw + #{$b}) + $important;
}

/// Статья - https://habrahabr.ru/post/310186/
// миксин для плавной адаптации отступов, размеров ширины, высоты, шрифта и т.д.
@mixin elastic($val-min, $val-max, $viewport-min, $viewport-max, $prop-name: 'font-size', $important: false, $units: px, $fallback: true) {
  // ------- prepare incoming data -------
  $val-min: strip-units($val-min);
  $val-max: strip-units($val-max);
  $viewport-min: strip-units($viewport-min);
  $viewport-max: strip-units($viewport-max);

  @if $important {
    $important: ' !important';
  } @else {
    $important: '';
  }
  // ------- END prepare incoming data -------

  // @debug type-of($viewport-min + $units); //=> string

  #{$prop-name}: $val-min + $units + $important;

  @include media($viewport-min * 1px) {
    @if ($fallback) {
      #{$prop-name}: (($val-min + $val-max) / 2) + $units + $important;
    }
    #{$prop-name}: responsive-size($val-min, $val-max, $viewport-min, $viewport-max, $important, $units);
  }

  @include media($viewport-max * 1px) {
    #{$prop-name}: $val-max + $units + $important;
  }
}
